!
!     AutoFlat     Mean of the set of scientific images.
!     Copyright (C) 2000-4  Filip Hroch, Masaryk University, Brno, CZ
!

      Program AutoFlat

! Experimental version #5.
!
! Experimentalni verze 5.
! predchozi verze asi moc nefungovaly!!!
!
! Toto je nejdrsnejsi verze. Pocita primo median a tak
! potrebuje opravdu hodne pameti -- typicky desitky Mb.
!

! Vyvoreni autoflat-fieldu z mnoha CCD snimku.
!
! FH, Rijen 1997
! FH, duben 1998
! FH, cerven 1998
! FH, zari 1998
! FH, rijen 1998, 7ho - vypada to velmi dobre, i drsne testovaci snimky 
!                   to uspesne projelo
! FH, cerven 1999 - dynamicke alokovani 
! FH, prosinec 2004 - hlavicka
!
! Porad je to jen experimenatlni verze!
! Opatrnost nutna!
!


! Library for dynamical list handling
 use LibList

implicit none

! Parameters:

!    Version:
       Character(len=80),parameter :: version = 'Autoflat v. 0.0.5 - F90' 

!   Config. file
       Character(len=80),parameter :: CFILE = 'autoflat.cfg'

! Initial parameters. 
!    Output image name:
       Character(len=256) :: nameflat='autoflat.fits'

!    Saturace:
       Real :: saturace = 65535.0     

!    Output mean:
       Real :: level = 10000.0
! LEVEL je vysledna predpokladana uroven medianu, kvuli zaokrouhlovacim
! chybam by nemela byt mensi nez 10 000

!    Minimum of values
       Real :: MINRANGE = 0.0

!    Maximum of values
       Real :: MAXRANGE = 65535.0

!    Step over image:
       Integer :: nstep = 4

       Logical :: simple,extend,anyf,exist
! undeflow or overflow has been occured during flat-field creation
       Logical :: underflow = .false., overflow = .false.
       Integer :: i,j,k,l,n,ilist,nobs,maxobs
       Integer :: istat, ostat ,bitpix, naxis, naxes(2) 
       Integer :: BlockSize,pcount,gcount

! image dimensions
       Integer ::  nx = -1, ny = -1 
! image
       Real :: value, x, datum, skymod, skysig, skyskw, medsig, medmed 
       Real :: rl, r, mainsig, exptime
       Real, allocatable :: flat(:,:), fbuf(:)
       Real :: bscale, bzero, s
       real, pointer :: ccd(:,:)
       Character(len=256) :: sb
       Character(len=80) :: buf, dateobs,masterdateobs,filter,masterfilter
       character(len=80),allocatable :: alldate(:), newdate(:)

       write(*,*) trim(version)

! cteni parametru
      call readpar(CFILE, nameflat, saturace, level, MINRANGE, MAXRANGE, nstep)

       medmed = MAXRANGE
! je aktualni pocet obrazku
       n = 0
! nacteni jmena souboru, ze STDIN
       Do
         Do
           Read(*,'(A)',end=20,err=667) sb
	   if( sb /= ' ' ) exit           ! preskoceni prazdneho radku
         enddo
         write(*,*) trim(sb),':'

         istat = 0
! input initialisation of a current file
         Call ftopen(25,sb,0,BlockSize,istat)
         Call ftghpr(25,2,simple,bitpix,naxis,naxes,pcount,gcount,extend,istat)
         if( istat /= 0 ) goto 666
         CALL ftgkye(25,'BSCALE',bscale,buf,istat)
         CALL ftgkye(25,'BZERO',bzero,buf,istat)
         if( istat /= 0 ) then
            istat = 0
            bscale = 1.0
            bzero = 0.0
         endif
         exptime = 0.0
         CALL ftgkye(25,'EXPTIME',exptime,buf,istat)
         if( istat /= 0 ) then
            write(*,*) 'EXPTIME keyword not found.'
            istat = 0
         endif
         dateobs = ''
         CALL ftgkys(25,'DATE-OBS',dateobs,buf,istat)
         if( istat /= 0 ) then
            write(*,*) 'DATE-OBS keyword not found.'
            istat = 0
         endif
         filter = ''
         CALL ftgkys(25,'FILTER',filter,buf,istat)
         if( istat /= 0 ) then
            write(*,*) 'FILTER keyword not found.'
            istat = 0
         endif

! first image - internal buffers initialisation
         if( nx < 0 .and. ny < 0 )then	 
            nx = naxes(1)  
            ny = naxes(2)

            ilist = 0
            Call InitList ( nx, ny, ccd, ilist )

            Allocate( flat(nx,ny) )
            if( .not. allocated(flat) ) Stop 'Not enought memory.'
            Allocate( fbuf(nx*ny) )
            if( .not. allocated(fbuf) ) Stop 'Not enought memory.'

            flat = 0.0 
            fbuf = 0.0

            nobs = 0
            maxobs = 2
            allocate(alldate(maxobs))
            masterfilter = filter
            masterdateobs = dateobs

         else      
! add  next image
            if( nx /= naxes(1) .or. ny /= naxes(2) ) &
              stop 'Dimensions of different images are quite different.'

            Call AddItem ( nx, ny, ccd, ilist )
	      
          endif 
          if( ilist /=0 ) stop 'Array initialisation failed.'
! image No.
         n = n + 1
       
! image - data input
         call FTG2DE(25,1,minrange,nx,nx,ny,ccd,anyf,istat)
         if( istat /= 0 ) goto 666

! zavreni obrazku
         call FTCLOS(25,istat)
         if( istat /= 0 ) goto 666

! z kazdeho nstep-ho pixelu obrazku se udela lokalni median
!        write(*,*) nx,ny,nstep,ccd(510,340)
!        the line do not work under SGI compiler (?)
!        fbuf = pack( ccd(1:nx:nstep,1:ny:nstep), .true.)
!        l = (nx*ny)/nstep**2
! but this works:
         l = 0
         do i = 1, nx, nstep
            do j = 1, ny, nstep
               l = l + 1
               fbuf(l) = ccd(i,j)
            enddo
         enddo
                 
        Call RobustMean(fbuf, l, skymod, skysig)
        i = 0
        Call PutPar(n, skymod, skysig, i)
        if( i /= 0 ) stop 'p1'

        WRITE(*,*) '  No., Median, skysig, n:',n,skymod,skysig,l

        if( abs(skymod - level) < abs(medmed - level) )then
           medmed = skymod
           medsig = skysig
        endif
	
        write(buf,'(a, 2x, a, f10.1)') trim(dateobs),trim(filter),exptime
        nobs = nobs + 1
        if( nobs > maxobs ) then
           allocate(newdate(maxobs))
           newdate = alldate
           deallocate(alldate)
           maxobs = 2*maxobs
           allocate(alldate(maxobs))
           alldate(1:maxobs/2) = newdate
           deallocate(newdate)
        endif
        alldate(nobs) = buf

        if( masterfilter /= filter ) write(*,*) 'Key keyword: FILTER differs.'

     enddo
20   continue

     if( n <= 0 ) stop 'No input image.'

     write(*,*) ' Number of the input images: ',n

!! vypocet medianu SKYSIGu
!     l = 0
!     do i = 1, n
!        call getpar(i, skymod, skysig, l)
!        fbuf(i) = skysig
!      enddo
!      if( l /= 0 ) stop 'l1'
!      l = n
!      Call RobustMean(fbuf, l, medsig, SKYSIG)
!      write(*,*) 'SkySig median =', medsig,l
!
!! vypocet medianu SKYMODu
!     l = 0
!     do i = 1, n
!        call getpar(i, skymod, skysig, l)
!        fbuf(i) = skymod
!      enddo
!      if( l /= 0 ) stop 'l2'
!      l = n
!      Call RobustMean(fbuf, l, medmed, SKYSIG)
!      write(*,*) 'SkyMod median =', medsig,l

! prumerna hodnota SKYSIG na urovni 'level'
      mainsig = level/medmed*medsig
      write(*,*) 'mainsig,medmed,medsig=',mainsig, medmed, medsig 

! prepocet vsech obrazku tak, jako by mely stejne SKYSIG
      do k = 1, n
        l = 0
        call getpar(k, skymod, skysig, l)
        if( l /= 0 ) stop 'l4'
! intenzity se nasobi timto cislem, aby se dostala intenzita 'level'
        rl = level / skymod
! prepocet 'SKISIG' pro tento obrazek na standardni
        r = mainsig / skysig
 
        write(*,*) k,' : ',r,rl,' (level, sig)'
        l = 0
        call getimage(k, ccd, l)
        if( l /= 0 ) stop 'l10' 
!        ccd = rl*ccd
        ccd = r*(ccd - skymod) + level

!         l = 0
!         do i = 1, nx, nstep
!            do j = 1, ny, nstep
!               l = l + 1
!               fbuf(l) = ccd(i,j)
!            enddo
!         enddo
!                 
!        Call RobustMean(fbuf, l, skymod, skysig)
!        write(*,*) "k, mean, sig=",k,skymod,skysig

!        do j = 1, ny
!          do i = 1, nx
!            x = ccd(i,j) 
!            x = r*(x -  skymod) + level
!            ccd(i,j)  = x
!           enddo
!        enddo
        l = 0
        call putimage(k, ccd, l)
        if( l /= 0 ) stop 'l11' 

      enddo

!       print *,i,j,fflat(i,j)
! konecny vypocet flat-fieldu

       Do j = 1,ny
         Do i = 1,nx
           l = 0
           do k = 1, n
              call getimage(k, ccd, l)
              if( l /= 0 ) stop 'ff1'
              fbuf(k) = ccd(i,j)
           enddo
           l = n
           Call RobustMean(fbuf, l, SKYMOD, SKYSIG)
           
!           if( l .le. 10 ) print *,'l=',l
! range checking
!           if ( skymod < MINRANGE ) then
!             underflow = .true.
!             skymod = MINRANGE
!           elseif ( skymod > MAXRANGE ) then
!             overflow = .true.
!             skymod = MAXRANGE
!           endif
!           if ( skymod <= 0 ) then
!             underflow = .true.
!             skymod = level
!           elseif ( skymod >= 2**bitpix/2 ) then
!!            NOT CORRECT, bug in FITSIO lib... correct value=2**bitpix !!!
!             overflow = .true.
!             skymod = level
!           endif

           flat(i,j) = skymod

         enddo
       enddo

       if( underflow ) then
          write(*,*) 'An undreflow has been occured during flat-fielding.'
       endif
       if( overflow ) then
          write(*,*) 'An overflow has been occured during flat-fielding.'
       endif

! konecny vypocet medianu
!        see line 144
!        fbuf = pack( flat(1:nx:nstep,1:ny:nstep), .true.)
!        l = (nx*ny)/nstep**2
        l = 0
        do i = 1, nx, nstep
          do j = 1, ny, nstep
             l = l + 1
             fbuf(l) = flat(i,j)
          enddo
        enddo

        Call RobustMean(fbuf, l, SKYMOD, SKYSIG)

        WRITE(*,*) '     Final median, skysig, n=',SKYMOD,skysig,l

! remove a previous autoflat image
       Inquire(file=nameflat,exist=exist)
       if( exist ) then
         open(26,file=nameflat)
         close(26,status='DELETE')
       endif

! Vytvoreni vystupniho obrazku
       call ftinit(26,nameflat,1,istat)
! zapsani informace do hlavicky
! dimenze a ostatni parametry se berou podle posledniho obrazku.
! pokud maji obrazky pretim odlisne dimenze, vysledek je nedefinovan 
       extend = .FALSE.
       call FTPHPS(26,bitpix,naxis,naxes,istat)
       call FTPKYS(26,'OBJECT','Flat-field',' ',istat)
       call FTPKYE(26,'BSCALE',bscale,10,' ',istat)
       call FTPKYE(26,'BZERO',bzero,10,' ',istat)
       call FTPKYE(26,'SKYMOD',skymod,10,'Mean level',istat)
       call FTPKYE(26,'SKYSIG',skysig,10,'Standard deviation',istat)
       call ftpkys(26,'FILTER',masterfilter,'filter of the first on input',istat)
       call ftpkys(26,'DATE-OBS',masterdateobs,'UTC of the first on input',istat)

       if( nobs > 0 ) then
           write(buf,'(a,i5,a)') 'The image is a result of robust average of ',nobs,' exposure(s).'
           call ftpcom(26,buf,istat)
           call ftpcom(26,'The time of start, filter and exposure time for each image used:',istat)
           do i = 1, nobs
              call ftpcom(26,alldate(i),istat)
           enddo
           call ftpcom(26,'All times are derived from DATE-OBS, FILTER and EXPTIME keywords.',istat)
        endif

! komentar
!       call FTPCOM(26,' ',istat)
!       call FTPCOM(26,'Carefully!',istat)
       BUF='This file has been computed by the experimental code:'
       call FTPCOM(26,buf,istat)
       call FTPCOM(26,version,istat)

!       write(*,*) 'parametry FITSu:',bitpix,naxis,naxes,istat
! zapsani  dat
       call FTP2DE(26,1,nx,nx,ny,flat,istat)
! Zavreni souboru
       call FTCLOS(26,istat)
666    if( istat /= 0 )then
        write(*,*) 'The following error(s) has been occured:'
        do
          Call ftgmsg(buf)
          if( buf == ' ' ) exit
          write(*,*) trim(buf)
        enddo
         
       endif

       Stop 'Bye.'    
   
 667 Continue
       Stop 'I/O error on input.'
     
       end 

