
#define VERSION "PICKO Version 1.1, Copyright (C) 1998-9 F.Hroch, Masaryk University, Brno, CZ"

#define VER "File created by the PICKO Version 1.1"

#define FITSSIZE   2880     /* size of the FITS data bufer */
#define HEADSIZE    290     /* length of the head Buil's PIC file */  
#define MAXTYPE      2      /* number of the known file types */

typedef struct _pichead {
  int signature;   /* FC for uncompressed data, FB for compressed data */
  int version;     /* 31 in this version */
  int headsize;    /* 290 bytes */
  char imagename[33]; 
  char asocname[33];
  int nrows,nlines; /* Number of rows and lines */
  int dataformat;  /* data format: value 2 = 16-bit integer */
  int datatype;    /* data type: value 3 = integer */
  int camera;      /* camera identification */
  int x1,y1,x2,y2; /* corners(?) coordinates */ 
  int binX,binY;   /* Binning X,Y */
  int plans;       /* number of color plans */
  char date[11];
  char time[15];
  int hilev,lolev; /* hight and low level */
  int hilev2,lolev2; /* fractional part of hight and low level */
  int integration; /* integration time */
  char comment1[81],comment2[81];
} HEAD;

/*
> 
> Dear Sir,
> 
> The PIC format includes a 290-byte header, followed by the image itself, 
> line after line, compressed or not. The files must have a .PIC extension.
> 
> The header contains the following information:
> 
> Signature			1 byte (value: FC for uncompressed data, FB for 
> 				compressed data)
> Version 			1 byte (value: 31 in this version)
> Header size                     2 bytes (value: 290 bytes)
> Image name			32 bytes
> Name of associated image	32 bytes
> Number of rows                  2 bytes
> Number of lines                 2 bytes
> Data format			2 bytes (value: 2 = 16-bit integer)
> Data type			2 bytes (value: 3 = integer)
> Reserved			2 bytes
> Camera identification		2 bytes
> X1 coordinate			2 bytes
> Y1 coordinate			2 bytes
> X2 coordinate			2 bytes
> Y2 coordinate			2 bytes
> Binning X			2 bytes
> Binning Y			2 bytes
> Number of colour plans          2 bytes
> Date 				10 bytes
> Time				14 bytes
> High level			2 bytes
> Low level			2 bytes
> Fractional part of high level	2 bytes
> Fractional part of low level	2 bytes
> Integration time                4 bytes
> Comment #1			80 bytes
> Comment #2 			80 bytes
> 
> The data are stored line after line (2-
> bytes per pixel - signed 16-bit integers, with low part first, and high part 
> next).
> 
> The normal format is uncompressed.
> 
> The important field are: 
> 
> Signature
> Version
> Data format
> Data type
> Number of rows
> Number of lines
> 
> Best regards
> 
> Christian Buil
> 

*/


























